SystemOrganization addCategory: #MartinDiasPersonalStuff!

!SystemOrganizer methodsFor: '*MartinDiasPersonalStuff' stamp: 'MartinDias 1/10/2012 17:39'!
promoteCategoriesMatching: match

	| categories matchingCategories sortedCategories |
	categories := self categories.
	matchingCategories := categories select: [ :c | match match: c ].
	sortedCategories := matchingCategories , (categories copyWithoutAll: matchingCategories).
	self categories: sortedCategories.! !

!MCCacheRepository class methodsFor: '*martindiaspersonalstuff' stamp: 'MartinDias 11/22/2011 17:36'!
marianoDefaultWithDirectory: aDirectory
	self checkCacheDirectory.
	^ default ifNil: [default := self new directory: aDirectory]! !

!MCCacheRepository class methodsFor: '*martindiaspersonalstuff' stamp: 'MartinDias 11/22/2011 17:36'!
marianoReset 
	default := nil.! !

!SmalltalkImage methodsFor: '*martindiaspersonalstuff' stamp: 'MartinDias 11/22/2011 17:36'!
saveAs: imageName inDirectoryNamed: aDirectoryString

	| newName index |
	
	(FileDirectory default fileExists: (aDirectoryString , imageName, '.' , FileDirectory changeSuffix))
		ifTrue: [
			newName := (FileDirectory on: aDirectoryString ) nextNameFor: imageName extension: FileDirectory imageSuffix.
			"newName := UIManager default
				request: 'Please enter the name for the new image:'
				initialAnswer: newName."
			index := newName findLast: [:c | c = $.].
			newName := newName copyFrom: 1 to: (index - 1).
			
			]
		ifFalse: [ newName := imageName ].
	newName isEmptyOrNil
		ifTrue: [ ^ self ].
	(SourceFiles at: 2) ifNotNil:
		[self closeSourceFiles; "so copying the changes file will always work"
			 saveChangesInFileNamed: (aDirectoryString , newName, '.' , FileDirectory changeSuffix)].
	^self saveImageInFileNamed: (aDirectoryString , newName, '.', FileDirectory imageSuffix)! !

Object subclass: #ConfigurationOfMartinDias
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'MartinDiasPersonalStuff'!

!ConfigurationOfMartinDias commentStamp: 'MarianoMartinezPeck 11/22/2011 17:02' prior: 0!
Explanation here: http://marianopeck.wordpress.com/2011/11/19/loading-projects-and-building-your-own-images-with-metacello/

Use:
ConfigurationOfMartinDias loadFuel.
ConfigurationOfMartinDias buildFuelImage.!

!ConfigurationOfMartinDias class methodsFor: 'development support' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMartinDias class methodsFor: 'private' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMartinDias class methodsFor: 'building' stamp: 'sdas 10/28/2011 22:48'!
buildFuelImage
	FuelImageBuilder new buildImage.! !

!ConfigurationOfMartinDias class methodsFor: 'building' stamp: 'MartinDias 6/29/2012 11:55'!
buildSlotImage
	SlotImageBuilder new buildImage.! !

!ConfigurationOfMartinDias class methodsFor: 'private' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMartinDias class methodsFor: 'private' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMartinDias class methodsFor: 'metacello tool support' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMartinDias class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:23'!
loadFuel
	FuelImageBuilder new loadPackages: 'Fuel'! !

!ConfigurationOfMartinDias class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
project

	^self new project! !

!ConfigurationOfMartinDias class methodsFor: 'development support' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMartinDias methodsFor: 'baselines' stamp: 'MartinDias 8/30/2012 11:14'!
baseline10: spec 
        <version: '1.0-baseline'>
        
	spec for: #pharo do: [
		spec blessing: #baseline.
		spec
			project: 'Fuel' with: [
			spec
				className: 'ConfigurationOfFuel';
				loads: #('FuelCompatibilityBeforePharo20' 'Fuel' 'FuelTests' 'FuelMetalevel' 'FuelMetalevelTests' 'FuelUtilities'  'FuelBenchmarks' 'FuelProgressUpdate');
				file: 'ConfigurationOfFuel';
				versionString: '1.8';
				repository: 'http://ss3.gemstone.com/ss/Fuel' ].

		spec repository: 'http://ss3.gemstone.com/ss/PharoTaskForces'.

			
"		spec
			project: 'Nautilus' with: [
			spec
				className: 'ConfigurationOfNautilus';
				loads: #('core');
				file: 'ConfigurationOfNautilus';
				versionString: #development;
				repository: 'http://ss3.gemstone.com/ss/Nautilus' ].
"			
		spec
			project: 'OmniBrowser' with: [
			spec
				className: 'ConfigurationOfOmniBrowser';
				loads: #('default');
				file: 'ConfigurationOfOmniBrowser';
				versionString: #stable;
				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
			
		spec
			group: 'FuelImage' with: #('BaseImage' 'Fuel');
			group: 'SlotImage' with: #('BaseImage' 'PharoTaskForces');
			group: 'BenchmarkImage' with: #('BaseImage')
			 ].

	spec for: #'pharo1.1.x' do: [ spec group: 'BaseImage' with: #() ].
	spec for: #'pharo1.2.x' do: [ spec group: 'BaseImage' with: #() ].
	spec for: #'pharo1.3.x' do: [ spec group: 'BaseImage' with: #() ].
	spec for: #'pharo1.4.x' do: [ spec group: 'BaseImage' with: #() ]. 
	spec for: #'pharo2.0.x' do: [ spec group: 'BaseImage' with: #() ]. 
! !

!ConfigurationOfMartinDias methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

Object subclass: #GeneralImageBuilder
	instanceVariableNames: ''
	classVariableNames: 'BuildOffline'
	poolDictionaries: ''
	category: 'MartinDiasPersonalStuff'!

GeneralImageBuilder subclass: #BenchmarkImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MartinDiasPersonalStuff'!

!BenchmarkImageBuilder methodsFor: 'saving' stamp: 'MartinDias 7/15/2012 12:43'!
baseImageName
	^ SystemVersion current asImageName, '-Benchmark'! !

!BenchmarkImageBuilder methodsFor: 'as yet unclassified' stamp: 'MartinDias 7/15/2012 12:44'!
customPreferences
	super customPreferences.
	Debugger logFileName: 'BenchmarkDebug.log'.
	
! !

!BenchmarkImageBuilder methodsFor: 'loading' stamp: 'MartinDias 7/15/2012 12:42'!
imageGroupNameToLoad
	^ 'BenchmarkImage'.	
! !

!BenchmarkImageBuilder methodsFor: 'as yet unclassified' stamp: 'MartinDias 7/15/2012 12:42'!
loadImagePackages
 	Gofer new 
		url: 'http://ss3.gemstone.com/ss/Fuel'; 
		package: 'ConfigurationOfFuel'; 
		load.
 	
	(Smalltalk classNamed: #ConfigurationOfFuel) project lastVersion 
		load: #(BenchmarksAllBinarySerializers).
 	
	Gofer new 
		url: 'http://www.squeaksource.com/FuelExperiments'; 
		package: 'FuelBenchmarks'; 
		load.
 	
	(Smalltalk classNamed: #FLBenchmarkScriptLoader) install.! !

!BenchmarkImageBuilder methodsFor: 'repositories' stamp: 'MartinDias 7/15/2012 12:44'!
repositoryName 
	^ 'http://ss3.gemstone.com/ss/MartinDiasPersonalStuff'! !

GeneralImageBuilder subclass: #FuelImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MartinDiasPersonalStuff'!

!FuelImageBuilder methodsFor: 'saving' stamp: 'MartinDias 4/3/2012 10:31'!
baseImageName
	^ SystemVersion current asImageName, '-Fuel'! !

!FuelImageBuilder methodsFor: 'as yet unclassified' stamp: 'MartinDias 6/29/2012 11:41'!
customPreferences
	super customPreferences.
	Debugger logFileName: 'FuelDebug.log'.
	
! !

!FuelImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:22'!
imageGroupNameToLoad
	^ 'FuelImage'.	
! !

!FuelImageBuilder methodsFor: 'repositories' stamp: 'MartinDias 11/22/2011 16:14'!
repositoryName 
	^ 'http://ss3.gemstone.com/ss/Fuel'! !

!FuelImageBuilder methodsFor: 'loading' stamp: 'MartinDias 8/30/2012 00:13'!
versionToLoad
	^ '1.8'
! !

!GeneralImageBuilder class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/27/2011 14:36'!
buildOffline
	BuildOffline ifNil: [ BuildOffline := false ].
	^ BuildOffline! !

!GeneralImageBuilder class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/27/2011 14:37'!
buildOffline: aBoolean
	BuildOffline := aBoolean! !

!GeneralImageBuilder methodsFor: 'building' stamp: 'MarianoMartinezPeck 10/30/2011 16:12'!
buildImage
	self loadImagePackages.
	self generalImagePreferences.
	self customPreferences.
	self cleanSystem.
	self lastActions.
	self saveImage.! !

!GeneralImageBuilder methodsFor: 'cleaning' stamp: 'MartinDias 1/10/2012 17:42'!
cleanSystem
	SystemWindow allSubInstancesDo: [:window | window delete].

	"Clear Monticello Caches"
	MCFileBasedRepository flushAllCaches.
	MCMethodDefinition shutDown.
	MCDefinition clearInstances.

	"Cleanup Smalltalk"
	Smalltalk flushClassNameCache.
	
	"Cleanup System Memory"
	Smalltalk garbageCollect.
	Symbol compactSymbolTable.
	
"	ScriptLoader new cleanUpForRelease.	"

	"put back the author"
	Author fullName: self repositoriesUserName.
	! !

!GeneralImageBuilder methodsFor: 'preferences' stamp: 'MartinDias 6/29/2012 11:41'!
customPreferences
	self loadFonts.
	
! !

!GeneralImageBuilder methodsFor: 'preferences' stamp: 'MartinDias 6/29/2012 11:41'!
generalImagePreferences
	UITheme currentSettings fastDragging: true.
	CodeHolder showAnnotationPane: true.
	MCCodeTool showAnnotationPane: true.
	Deprecation raiseWarning: true.
	Debugger alwaysOpenFullDebugger: true.! !

!GeneralImageBuilder methodsFor: 'building' stamp: 'MarianoMartinezPeck 11/22/2011 17:03'!
generalPreLoad
	MCCacheRepository marianoReset. 
	MCCacheRepository marianoDefaultWithDirectory: self sharedPackageCacheDirectory.
	MCDirectoryRepository defaultDirectoryName: self sharedPackageCacheName.
	Author fullName: self repositoriesUserName.
	
! !

!GeneralImageBuilder methodsFor: 'saving' stamp: 'MartinDias 6/29/2012 11:35'!
imageDirectory
	^ 'D:\Pharo\images\'! !

!GeneralImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:22'!
imageGroupNameToLoad
	^ self subclassResponsibility ! !

!GeneralImageBuilder methodsFor: 'building' stamp: 'MartinDias 1/10/2012 17:44'!
lastActions
	self putMyCategoriesAtTheBeginning.
	self putMyRepositoriesAtTheEnd.
	self setSqueakSourceUsernameAndPassword.! !

!GeneralImageBuilder methodsFor: 'fonts' stamp: 'MartinDias 6/29/2012 11:32'!
loadBalloonFont
		self loadSetting: #balloonFont withBlock: [StandardFonts balloonFont: (StrikeFont familyName: 'Bitmap DejaVu Sans' pointSize: 9 emphasized: 0)].
! !

!GeneralImageBuilder methodsFor: 'fonts' stamp: 'MartinDias 6/29/2012 11:32'!
loadButtonFont
		self loadSetting: #buttonFont withBlock: [StandardFonts buttonFont: (StrikeFont familyName: 'Bitmap DejaVu Sans' pointSize: 9 emphasized: 0)].
! !

!GeneralImageBuilder methodsFor: 'fonts' stamp: 'MartinDias 6/29/2012 11:32'!
loadCodeFont
		self loadSetting: #codeFont withBlock: [StandardFonts codeFont: (StrikeFont familyName: 'Bitmap DejaVu Sans' pointSize: 12 emphasized: 0)].
! !

!GeneralImageBuilder methodsFor: 'fonts' stamp: 'MartinDias 6/29/2012 11:32'!
loadDefaultFont
		self loadSetting: #defaultFont withBlock: [StandardFonts defaultFont: (StrikeFont familyName: 'Bitmap DejaVu Sans' pointSize: 12 emphasized: 0)].
! !

!GeneralImageBuilder methodsFor: 'preferences' stamp: 'MartinDias 6/29/2012 12:52'!
loadFonts
	(self class withAllSuperclasses gather: [:c | c methodsInCategory: 'fonts']) do: [:m | self perform: m].
	SettingBrowser refreshAllSettingBrowsers.! !

!GeneralImageBuilder methodsFor: 'fonts' stamp: 'MartinDias 6/29/2012 11:32'!
loadHaloFont
		self loadSetting: #haloFont withBlock: [StandardFonts haloFont: (StrikeFontSet familyName: 'Accuny' size: 10 emphasized: 0)].
! !

!GeneralImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:22'!
loadImagePackages
	self loadPackages: self imageGroupNameToLoad.! !

!GeneralImageBuilder methodsFor: 'fonts' stamp: 'MartinDias 6/29/2012 11:32'!
loadListFont
		self loadSetting: #listFont withBlock: [StandardFonts listFont: (StrikeFont familyName: 'Bitmap DejaVu Sans' pointSize: 12 emphasized: 0)].
! !

!GeneralImageBuilder methodsFor: 'fonts' stamp: 'MartinDias 6/29/2012 11:32'!
loadMenuFont
		self loadSetting: #menuFont withBlock: [StandardFonts menuFont: (StrikeFont familyName: 'Bitmap DejaVu Sans' pointSize: 12 emphasized: 0)].
! !

!GeneralImageBuilder methodsFor: 'loading' stamp: 'MartinDias 8/30/2012 00:14'!
loadPackages: packagesOrGroups
	| version repo |
	self generalPreLoad.
	version := (ConfigurationOfMartinDias project version: #bleedingEdge).
	self class buildOffline 
		ifTrue: [ 
			repo := MCDirectoryRepository new.
  			repo directory: self sharedPackageCacheDirectory.
 	 		version repositoryOverrides: (OrderedCollection with: repo).
			 ].
	version load: packagesOrGroups.
	 ! !

!GeneralImageBuilder methodsFor: 'loading' stamp: 'MartinDias 6/29/2012 11:35'!
loadSetting: aName withBlock: aBlock 
	aBlock
		on: Error
		do: [| message |
			message := 'Error while changing the setting: ' , aName.
			self logCr: message] ! !

!GeneralImageBuilder methodsFor: 'fonts' stamp: 'MartinDias 6/29/2012 11:32'!
loadUpdateFontsAtImageStartup
		self loadSetting: #updateFontsAtImageStartup withBlock: [FreeTypeSettings updateFontsAtImageStartup: false].
! !

!GeneralImageBuilder methodsFor: 'fonts' stamp: 'MartinDias 6/29/2012 11:32'!
loadWindowTitleFont
		self loadSetting: #windowTitleFont withBlock: [StandardFonts windowTitleFont: (StrikeFont familyName: 'Bitmap DejaVu Sans' pointSize: 12 emphasized: 0)].
! !

!GeneralImageBuilder methodsFor: 'building' stamp: 'MartinDias 1/10/2012 17:44'!
putMyCategoriesAtTheBeginning

	Smalltalk organization promoteCategoriesMatching: self baseImageName , '*'! !

!GeneralImageBuilder methodsFor: 'private' stamp: 'MarianoMartinezPeck 11/1/2011 20:01'!
putMyRepositoriesAtTheEnd
	| myRepo |
	myRepo :=  MCRepositoryGroup default repositories 
		detect: [:each | each description = self repositoryName]
		ifNone: [ "this means it was loaded offline used the shared package cache, so I do nothing" ^ self ].
	MCRepositoryGroup default  removeRepository: myRepo.
	MCRepositoryGroup default  addRepository: myRepo.
! !

!GeneralImageBuilder methodsFor: 'file directories' stamp: 'MartinDias 6/29/2012 11:37'!
repositoriesPassword
	^ (FileDirectory default oldFileNamed: 'D:\Pharo\ssMartinDiasPassword.txt') contents
! !

!GeneralImageBuilder methodsFor: 'file directories' stamp: 'MartinDias 11/22/2011 16:55'!
repositoriesUserName
	^ 'MartinDias'
! !

!GeneralImageBuilder methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/27/2011 16:47'!
repositoryName
	^ self subclassResponsibility ! !

!GeneralImageBuilder methodsFor: 'saving' stamp: 'MartinDias 8/6/2012 16:39'!
saveImage

	Smalltalk saveAs: self imageDirectory, self baseImageName, Time now asMilliSeconds asString
! !

!GeneralImageBuilder methodsFor: 'private' stamp: 'MarianoMartinezPeck 11/22/2011 17:14'!
setSqueakSourceUsernameAndPassword
	"This sets the username and password in all repositories. The password must stored in a specific file in the machine where you are building this image."
	(MCRepositoryGroup default  repositories 
		select: [:each | (each isKindOf: MCHttpRepository) 
			and: [each locationWithTrailingSlash = self repositoryName]]) do: [:each |
			each 
				user: self repositoriesUserName;
				password: self repositoriesPassword.
			]! !

!GeneralImageBuilder methodsFor: 'file directories' stamp: 'MarianoMartinezPeck 10/21/2011 14:11'!
sharedPackageCacheDirectory.
	^ (FileDirectory on: self sharedPackageCacheName)
		assureExistence;
		yourself! !

!GeneralImageBuilder methodsFor: 'file directories' stamp: 'MartinDias 6/29/2012 11:40'!
sharedPackageCacheName
	^ 'D:\Pharo\localRepository\'! !

!GeneralImageBuilder methodsFor: 'loading' stamp: 'MartinDias 8/30/2012 00:12'!
versionToLoad

	^ #bleedingEdge! !

GeneralImageBuilder subclass: #SlotImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MartinDiasPersonalStuff'!

!SlotImageBuilder methodsFor: 'saving' stamp: 'MartinDias 6/29/2012 11:48'!
baseImageName
	^ SystemVersion current asImageName, '-Slot'! !

!SlotImageBuilder methodsFor: 'as yet unclassified' stamp: 'MartinDias 6/29/2012 11:48'!
customPreferences
	super customPreferences.
	Debugger logFileName: 'SlotDebug.log'.
	
! !

!SlotImageBuilder methodsFor: 'loading' stamp: 'MartinDias 6/29/2012 11:48'!
imageGroupNameToLoad
	^ 'SlotImage'.	
! !

!SlotImageBuilder methodsFor: 'as yet unclassified' stamp: 'MartinDias 8/24/2012 00:53'!
loadImagePackages

	Gofer it
		squeaksource3: 'PharoTaskForces';
		package: 'Slot';
		package: 'SlotTests';
		load.
	(Smalltalk at: #SlotVirus) perform: #spread.	

	Gofer it
		squeaksource3: 'PharoTaskForces';
		package: 'SlotsClassBuilderIntegration';
		load.

	Gofer new
		smalltalkhubUser: 'marianopeck' project: 'Tanker';
		package: 'ConfigurationOfTanker';
		load.

	(Smalltalk at: #ConfigurationOfTanker) loadBleedingEdge.

	Gofer new
		squeaksource: 'FuelExperiments';
		package: 'Carbono';
		package: 'CarbonoTests';
		load.! !

!SlotImageBuilder methodsFor: 'repositories' stamp: 'MartinDias 6/29/2012 11:48'!
repositoryName 
	^ 'http://ss3.gemstone.com/ss/PharoTaskForces'! !

!SystemVersion methodsFor: '*MartinDiasPersonalStuff' stamp: 'MartinDias 4/3/2012 10:31'!
asImageName 

	^ self version asString, '-', self highestUpdate asString! !
